=== debian/changelog ===
codec2 (1.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Working MUT watch file

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 17 Jul 2022 04:29:59 +0000
